<?php
/**
 *
 * mod_calculators
 *
 * @license        GNU/GPL, see LICENSE.php
 * mod_calculators is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 */
 
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$document=&JFactory::getDocument(); 
 
// Include the syndicate functions only once
require_once( dirname(__FILE__).DS.'mortgageHelper.php' );  // include helper.php file 
require_once( dirname(__FILE__).DS.'annuityHelper.php' );  // include helper.php file 

// Determine calculator type as selected in module parameters
$calcType = $params->get('paramCalculatorType', 'mortgage');
$showCredits = $params->get('paramShowCredits', 'yes');

$params->def('paramMortgageTemplate', 'default');
$params->def('paramAnnuityTemplate', 'default');
$params->def('paramMortgageCurrency', '$');
$params->def('paramAnnuityCurrency', '$');

if ($calcType=='mortgage') {
	$document->addStyleSheet('modules/mod_calculate/assets/mortgage/' . $params->get('paramMortgageTemplate') . '.css'); // include the css file for calculators
	
	// Init parameters
	$allow_amortization = $params->get( 'paramAmortization', 'yes' );
	$showMortgageTitle = $params->get( 'paramShowMortgageTitle', 'yes' );
	$params->def('paramMoPrincipal', 'yes');
	$mortgageTitle = $params->get( 'paramMortgageTitle', 'Mortgage Calculator' );
	
	modCalculatorsMortgageHelper::printMortgageCalcJS($params);
	
} elseif ($calcType=='annuity') {
	$document->addStyleSheet('modules/mod_calculate/assets/annuity/' . $params->get('paramAnnuityTemplate') . '.css'); // include the css file for calculators
	modCalculatorsAnnuityHelper::printAnnuityCalcJS($params);
	
	$showAnnuityTitle = $params->get( 'paramShowAnnuityTitle', 'yes' );
	$annuityTitle = $params->get( 'paramAnnuityTitle', 'Standard Annuity Calculator' );
}

$path = JModuleHelper::getLayoutPath('mod_calculate', $calcType ); // define the template path - tmpl/default.php

if (file_exists($path)) {
	require($path);
}
?>
