<?php
/**
 * Helper class for the calculators module
 * 
 * by Zapus Consulting, LLC
 *
 * @license        GNU/GPL, see LICENSE.php
 * mod_helloworld is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 */
defined( '_JEXEC' ) or die( 'Restricted access' ); 
 
class modCalculatorsMortgageHelper
{
	 /*
     * Runs the Mortgage Calculator
     *
     * @access public
     */    
	
	function printMortgageCalcJS( $params )	{
		
		?>
		
		<script type="text/javascript">
		function CalculateMortgage(loanAmount, interestRate, principalAdded, numYears, showAmort, amortByMonth, amortByYear, form)
		{
		
		var amount = parseFloat(loanAmount);
		var rate = parseFloat(interestRate) / 100 / 12;
		years = parseFloat(numYears);
		year=1;
		var moPrincipalAdded = parseFloat(principalAdded);
		var totalInterestPaid=0;
		var totalPrincipalPaid=0;
		var accumulatedPrincipal=0;
		var accumulatedInterest=0;
		var months = parseFloat(years) * 12;
		var htmlNumCols;

		moPayment = amount * rate / (1 - Math.pow((1+rate),-months));

		// if user adds principal each month make sure answer reflects this
		if (moPrincipalAdded !== 0) {
			moPaymentWithPrincipal = moPayment - moPrincipalAdded;
			form.moPayment.value = moPaymentWithPrincipal.toFixed(2);
		} else {
			form.moPayment.value = moPayment.toFixed(2);
		}
		
		// Print link
		html = '<html><head><link rel="stylesheet" href="<?php echo $this->baseurl ?>/modules/mod_calculate/assets/mortgage/<?php echo $params->get('paramMortgageTemplate'); ?>.css" type="text/css" /></head>';
		html += '<body class="amort_page"><div class="amort_print"><a HREF="javascript:window.print()">Print This Page</a></div>';
		
		// Summary
		html += '<div class="amort_summary"><span>Principal Loan Amount: $' + amount + '</span></br />';
		html += '<span>Term: ' + years + ' years</span><br />';
		html += '<span>Annual Interest Rate: ' + interestRate + '%</span><br />';
		html += '<span>Monthly Principal / Interest Payment: $' + form.moPayment.value + '</span></div>';
		
		// Table column headers
		html += '<table cellpadding="0" cellspacing="0" border="0" class="amort_schedule">';
		
		if (form.amortByMonth.checked==false) {
			html += '<th>Year</th>';
			html += '<th>Total Principal Paid</th>';
			html += '<th>Total Interest Paid</th>';
			html += '<th>New Principal Balance</th>';
			htmlNumCols = 4;
		} else if (form.amortByMonth.checked==true) {
			html += '<th>Month</th>';
			html += '<th>Monthly Interest Paid</th>';
			html += '<th>Monthly Principal Paid</th>';
			html += '<th>Total Interest Paid</th>';
			html += '<th>New Principal Balance</th>';
			htmlNumCols = 5;
			}

		
		if (form.amortByMonth.checked==true) {
			html += '<tr><td colspan="5" style="text-align:center;font-weight:bold;">Year ' + year + '</td></tr>';
		}
		
			for(i=1;i<=months;i++) {

			currentMoInterestPaid = amount * rate;
			currentMoPrincipal = moPayment - currentMoInterestPaid;
			newMoPrincipalBalance = amount - currentMoPrincipal;
			
			if (moPrincipalAdded !== 0) {
				newMoPrincipalBalance = newMoPrincipalBalance - moPrincipalAdded;
			}
			
			amount = newMoPrincipalBalance;

			// calculate the monthly accumulated principal and interest paid
			accumulatedPrincipal += currentMoPrincipal;
			accumulatedInterest += currentMoInterestPaid;
			
			yrs = i%12; // determine when each 'year' is hit
			
				if (form.amortByYear.checked==true) {
					
					if(yrs==0) { // output the table rows
						month = year*12;
						html += '<tr><td>' + year + '</td>';
						html += '<td><?php echo $params->get('paramMortgageCurrency'); ?> ' + accumulatedPrincipal.toFixed(2) + '</td>';
						html += '<td><?php echo $params->get('paramMortgageCurrency'); ?> ' + accumulatedInterest.toFixed(2) + '</td>';
						
						if (newMoPrincipalBalance.toFixed(2) <= 0) {
							html += '<td><?php echo $params->get('paramMortgageCurrency'); ?> ' + 0.00 + '</td></tr>';
							i = months+1;
						} else {
							html += '<td><?php echo $params->get('paramMortgageCurrency'); ?> ' + Math.abs(newMoPrincipalBalance.toFixed(2)) + '</td></tr>';
						}						
				
						year++;
					}
				} 	else if (form.amortByMonth.checked==true){
						month = i;
						
						html += '<tr><td>' + month + '</td>';
						html += '<td><?php echo $params->get('paramMortgageCurrency'); ?> ' + currentMoInterestPaid.toFixed(2) + '</td>';
						html += '<td><?php echo $params->get('paramMortgageCurrency'); ?> ' + currentMoPrincipal.toFixed(2) + '</td>';
						html += '<td><?php echo $params->get('paramMortgageCurrency'); ?> ' + accumulatedInterest.toFixed(2) + '</td>';
						
						if (newMoPrincipalBalance.toFixed(2) <= 0) {
							html += '<td><?php echo $params->get('paramMortgageCurrency'); ?> ' + 0.00 + '</td></tr>';
							i = months+1;
						} else {
							html += '<td><?php echo $params->get('paramMortgageCurrency'); ?> ' + Math.abs(newMoPrincipalBalance.toFixed(2)) + '</td></tr>';
						}
						
						// output yearly 'header' to represent the current year better to the reader
						if (yrs==0) {
							year++;
							if (year<=years) {
								html += '<tr><td colspan="' + htmlNumCols + '" style="text-align:center;font-weight:bold;">Year ' + year + '</td></tr>';
							}
						}
				}
			}

		html += '</table></body></html>'; // end of html

		if (form.showAmort.checked == true) {  // if user checked the show amortization box then open window and show table
			var amortWindow = window.open("", "Amortization", "width=650, height=600, scrollbars=1, resizeable=1, location=0");
			amortWindow.document.open();
			amortWindow.document.write(html);
			amortWindow.documnet.close();
		}

		}

		// resets the form values to default and erases values
		function resetMortgageForm(form) {
			form.loanAmount.value = "";
			form.interestRate.value = "";
			form.numYears.value = "";
			form.moPayment.value = "";
			form.moPrincipalAdded.value = "0.00";
			form.showAmort.checked = false;
			form.amortByMonth.disabled=true;
			form.amortByYear.disabled=true;
			form.amortByYear.checked=true;
			form.amortByMonth.checked=false;
		}	
		
		// disables amortization options when 'show amortization table' option is unchecked and vice versa
		function enableDisableFields(form) {
		
			if (form.showAmort.checked) {
				form.amortByMonth.disabled=false;
				form.amortByYear.disabled=false;
			} else {
				form.amortByMonth.disabled=true;
				form.amortByYear.disabled=true;
				form.amortByYear.checked=true;
				form.amortByMonth.checked=false;
			}
		}
		
		// make sure the amortization by month is unchecked when choosing the amortization by year
		function amortByYearCheck(form) {
			form.amortByYear.checked=true;
			form.amortByMonth.checked=false;
		}
		
		// make sure the amortization by year is unchecked when choosing the amortization by month
		function amortByMonthCheck(form) {
			form.amortByMonth.checked=true;
			form.amortByYear.checked=false;
		}
		
		</script>	
		
		<?php
	}
}
?>
